import os.path
import pyglet
import simplejson
import sys
import random
import geom

from math import cos, sin, radians, degrees, atan, atan2, pi, sqrt

import cocos
from cocos.director import director
from cocos.scene import Scene
from cocos.layer.base_layers import Layer
from cocos.sprite import NotifierSprite, Sprite

from tiless_editor.plugins.sprite_layer import SpriteLayerFactory
from tiless_editor.layers.collision import CollisionLayer
from tiless_editor.tiless_editor import LayersNode

from gamectrl import GameCtrl
from boids import merge, seek, cap, avoid_group

WIDTH, HEIGHT = 800, 600
MAPFILE = 'data/map.json'

def main():
    # fix pyglet resource path
    pyglet.resource.path.append(os.path.join(os.path.abspath(os.path.dirname(__file__)), '..'))
    pyglet.resource.reindex()

    # initialize cocos director
    director.init(WIDTH, HEIGHT)

    main_scene = Scene()
    w = WallLayer()
    s = NotifierSprite('data/img/tipito.png')
    w.add(s)
    main_scene.add(w)

    director.run(main_scene)

class WallLayer(cocos.cocosnode.CocosNode):
    def __init__(self):
        super(WallLayer, self).__init__()
        self.batch = pyglet.graphics.Batch()



    def add(self, sprite):
        wd = sprite.image.width/2
        hd = sprite.image.height/2
        wh = 0
        x, y = sprite.position
        x = int(x)
        y = int(y)
        l = (x-wd, y-hd, wh, x+wd, y-hd, wh, x+wd, y+hd, wh, x-wd, y+hd, wh)
        l = (x-wd, y-hd, x+wd, y-hd, x+wd, y+hd, x-wd, y+hd)
        print l
        vertex_list = self.batch.add(4, pyglet.gl.GL_QUADS, None,
            ('v2i', l),
            ('c3B', [0, 0, 255]*4)
        )

    def draw(self):
        pyglet.gl.glPushMatrix()
        self.transform()
        self.batch.draw()
        pyglet.gl.glPopMatrix()
if __name__ == '__main__':
    main()
